require 'cht-lib-fabric/helpers/tokens'

module PlatformExtensions
  module TokenHelper
    module Authentication
      class << self
        QUERIES_TO_AUTHENTICATE = %w[awsAccountApiAccessStatusOverview awsAccountsApiAccessStatus awsAccountApiAccessStatus]

        def should_authenticate_request? (request)
          request.body.rewind
          request_body = request.body.read
          request.body.rewind

          is_graphql_request = request.request_method == "POST" && request.path.include?('/graphql')
          has_authenticated_queries = QUERIES_TO_AUTHENTICATE.any? { |query_name| request_body.include?("#{query_name}") }

          is_graphql_request && has_authenticated_queries
        end
      end

      def selective_assert_authenticated!
        if PlatformExtensions::TokenHelper::Authentication.should_authenticate_request? request
          assert_authenticated!
        end
      end
    end
  end
end

::Platform::Helpers::Tokens::Helpers.include PlatformExtensions::TokenHelper::Authentication
